/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.CcidS3PathRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CcidS3Path extends TableImpl<CcidS3PathRecord> {

    private static final long serialVersionUID = 687009980;

    /**
     * The reference instance of <code>CCID_S3_PATH</code>
     */
    public static final CcidS3Path CCID_S3_PATH = new CcidS3Path();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<CcidS3PathRecord> getRecordType() {
        return CcidS3PathRecord.class;
    }

    /**
     * The column <code>CCID_S3_PATH.ID_CCID_PATH</code>.
     */
    public final TableField<CcidS3PathRecord, Integer> ID_CCID_PATH = createField("ID_CCID_PATH", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>CCID_S3_PATH.IDDSR</code>.
     */
    public final TableField<CcidS3PathRecord, String> IDDSR = createField("IDDSR", org.jooq.impl.SQLDataType.VARCHAR(512), this, "");

    /**
     * The column <code>CCID_S3_PATH.S3_PATH</code>.
     */
    public final TableField<CcidS3PathRecord, String> S3_PATH = createField("S3_PATH", org.jooq.impl.SQLDataType.VARCHAR(1024).nullable(false), this, "");

    /**
     * Create a <code>CCID_S3_PATH</code> table reference
     */
    public CcidS3Path() {
        this(DSL.name("CCID_S3_PATH"), null);
    }

    /**
     * Create an aliased <code>CCID_S3_PATH</code> table reference
     */
    public CcidS3Path(String alias) {
        this(DSL.name(alias), CCID_S3_PATH);
    }

    /**
     * Create an aliased <code>CCID_S3_PATH</code> table reference
     */
    public CcidS3Path(Name alias) {
        this(alias, CCID_S3_PATH);
    }

    private CcidS3Path(Name alias, Table<CcidS3PathRecord> aliased) {
        this(alias, aliased, null);
    }

    private CcidS3Path(Name alias, Table<CcidS3PathRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> CcidS3Path(Table<O> child, ForeignKey<O, CcidS3PathRecord> key) {
        super(child, key, CCID_S3_PATH);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.CCID_S3_PATH_IDDSR_FK_IDX, Indexes.CCID_S3_PATH_IDX_UQ_DSR_CCID_PATH, Indexes.CCID_S3_PATH_IX_CCID_S3_PATH_8055281B0DD3DFFB, Indexes.CCID_S3_PATH_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<CcidS3PathRecord, Integer> getIdentity() {
        return Keys.IDENTITY_CCID_S3_PATH;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<CcidS3PathRecord> getPrimaryKey() {
        return Keys.KEY_CCID_S3_PATH_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<CcidS3PathRecord>> getKeys() {
        return Arrays.<UniqueKey<CcidS3PathRecord>>asList(Keys.KEY_CCID_S3_PATH_PRIMARY, Keys.KEY_CCID_S3_PATH_IDX_UQ_DSR_CCID_PATH);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<CcidS3PathRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<CcidS3PathRecord, ?>>asList(Keys.IDDSR_FK);
    }

    public DsrMetadata dsrMetadata() {
        return new DsrMetadata(this, Keys.IDDSR_FK);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CcidS3Path as(String alias) {
        return new CcidS3Path(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CcidS3Path as(Name alias) {
        return new CcidS3Path(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public CcidS3Path rename(String name) {
        return new CcidS3Path(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public CcidS3Path rename(Name name) {
        return new CcidS3Path(name, null);
    }
}
